﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Core.Layers;

namespace CompositeChart
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Declare a composite chart type
            this.ultraChart1.ChartType = ChartType.Composite;
            
            //Create a chart area
            ChartArea area = new ChartArea();
            this.ultraChart1.CompositeChart.ChartAreas.Add(area);

            //Create 6 different Y axis.
            // All 6 Y axis has data type - Numeric 
            AxisItem axis1 = new AxisItem();
            axis1.Extent = 20;
            axis1.DataType = AxisDataType.Numeric;
            axis1.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axis1.OrientationType = AxisNumber.Y_Axis;
            

            //By defaut the AxisRangeType = Automatic
            //You are able to set the axis menually with the code:
            //axis1.RangeType = AxisRangeType.Custom;
            //axis1.RangeMin = 1;
            //axis1.RangeMax = 100;
            axis1.LineColor = Color.Red;
            area.Axes.Add(axis1);

            AxisItem axis2 = new AxisItem();
            axis2.Extent = 70;
            axis2.DataType = AxisDataType.Numeric;
            axis2.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axis2.OrientationType = AxisNumber.Y_Axis;
            axis2.LineColor = Color.Blue;
            area.Axes.Add(axis2);

            AxisItem axis3 = new AxisItem();
            axis3.Extent = 120;
            axis3.DataType = AxisDataType.Numeric;
            axis3.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axis3.OrientationType = AxisNumber.Y_Axis;
            axis3.LineColor = Color.Blue;
            area.Axes.Add(axis3);

            AxisItem axis4 = new AxisItem();
            axis4.Extent = 170;
            axis4.DataType = AxisDataType.Numeric;
            axis4.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axis4.OrientationType = AxisNumber.Y_Axis;
            axis4.LineColor = Color.Green;
            area.Axes.Add(axis4);

            AxisItem axis5 = new AxisItem();
            axis5.Extent = 220;
            axis5.DataType = AxisDataType.Numeric;
            axis5.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axis5.OrientationType = AxisNumber.Y_Axis;
            axis5.LineColor = Color.Pink;
            area.Axes.Add(axis5);

            //Create a X axis of data type String
            //It is very importatnt to set poperty SetLabelAxisType = ContinuousData
            //because we intend to use LineChart
            AxisItem axisX = new AxisItem();
            axisX.DataType = AxisDataType.String;
            axisX.Labels.ItemFormatString = "<ITEM_LABEL>";
            axisX.OrientationType = AxisNumber.X_Axis;
            axisX.SetLabelAxisType = SetLabelAxisType.ContinuousData;
            axisX.ScrollScale.Visible = true;
            area.Axes.Add(axisX);


            //Create a ChartLayer for each series
            ChartLayerAppearance myColumnLayer = new ChartLayerAppearance();
            myColumnLayer.ChartType = ChartType.LineChart;
            myColumnLayer.ChartArea = area;

            ChartLayerAppearance myColumnLayer2 = new ChartLayerAppearance();
            myColumnLayer2.ChartType = ChartType.LineChart;
            myColumnLayer2.ChartArea = area;

            ChartLayerAppearance myColumnLayer3 = new ChartLayerAppearance();
            myColumnLayer3.ChartType = ChartType.LineChart;
            myColumnLayer3.ChartArea = area;

            //Example for AreaChart
            ChartLayerAppearance myColumnLayer4 = new ChartLayerAppearance();
            myColumnLayer4.ChartType = ChartType.AreaChart;
            myColumnLayer4.ChartArea = area;

            ChartLayerAppearance myColumnLayer5 = new ChartLayerAppearance();
            myColumnLayer5.ChartType = ChartType.LineChart;
            myColumnLayer5.ChartArea = area;


            //Create a DataTable with sample data
            //This data will be used like DataSource for our composite chart
            DataTable dt = new DataTable();
            dt.Columns.Add("LabCol");
            dt.Columns.Add("Monday");
            dt.Columns.Add("Tuesday");
            dt.Columns.Add("Wednesday");
            dt.Columns.Add("Thursday");
            dt.Columns.Add("Firday");

            dt.Rows.Add("Lab1", -10, -200, 290, 300, 450);
            dt.Rows.Add("Lab2",   2, -180, 260, 310, 470);
            dt.Rows.Add("Lab3", 5, 100, 280, 320, 430);
            dt.Rows.Add("Lab4", 7, 160, 270, 310, 440);
            dt.Rows.Add("Lab5", 9, 140, 250, 330, 480);
            dt.Rows.Add("Lab6", 10, 110, 280, 320, 530);
            

            //Create 6 different Series
            //One possible approach to for DataBinding
            NumericSeries series1 = new NumericSeries();
            series1.DataBind(dt, "Monday", "LabCol");
            series1.PEs.Add(new PaintElement(Color.Red));
            series1.Label = "Label series1: ";
            myColumnLayer.Series.Add(series1);
            ultraChart1.CompositeChart.Series.Add(series1);
            

            //Other possible approach for DataBinding
            NumericSeries series2 = new NumericSeries();
            series2.Label = "Label series2: ";
            series2.Data.LabelColumn = "LabCol";
            series2.Data.ValueColumn = "Tuesday";
            series2.Data.DataSource = dt;
            series2.DataBind();
            series2.PEs.Add(new PaintElement(Color.Blue));
            myColumnLayer2.Series.Add(series2);
            ultraChart1.CompositeChart.Series.Add(series2);
            

            NumericSeries series3 = new NumericSeries();
            series3.Label = "Label series3: " ;
            series3.DataBind(dt, "Wednesday", "LabCol");
            series3.PEs.Add(new PaintElement(Color.Yellow));
            myColumnLayer3.Series.Add(series3);
            ultraChart1.CompositeChart.Series.Add(series3);

            NumericSeries series4 = new NumericSeries();
            series4.Label = "Label series4: ";
            series4.DataBind(dt, "Thursday", "LabCol");
            series4.PEs.Add(new PaintElement(Color.Green));
            myColumnLayer4.Series.Add(series4);
            ultraChart1.CompositeChart.Series.Add(series4);

            NumericSeries series5 = new NumericSeries();
            series5.Label = "Label series5: " ;
            series5.DataBind(dt, "Firday", "LabCol");
            series5.PEs.Add(new PaintElement(Color.Pink));
            myColumnLayer5.Series.Add(series5);
            ultraChart1.CompositeChart.Series.Add(series5);

            // Set axis for each Chart Layer
            myColumnLayer.AxisX = axisX;
            myColumnLayer.AxisY = axis1;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer);

            myColumnLayer2.AxisX = axisX;
            myColumnLayer2.AxisY = axis2;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer2);

            myColumnLayer3.AxisX = axisX;
            myColumnLayer3.AxisY = axis3;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer3);

            myColumnLayer4.AxisX = axisX;
            myColumnLayer4.AxisY = axis4;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer4);

            myColumnLayer5.AxisX = axisX;
            myColumnLayer5.AxisY = axis5;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer5);

            LineAppearance la = new LineAppearance(ultraChart1);
            la.IconAppearance.Icon = SymbolIcon.Circle;
            la.IconAppearance.IconSize = SymbolIconSize.Large;
            la.LineStyle.EndStyle = LineCapStyle.DiamondAnchor;
            

            LineChartAppearance dd = new LineChartAppearance();
            dd.LineAppearances.Add(la);
            

            myColumnLayer.ChartTypeAppearance =  dd;


            ultraChart1.Tooltips.FormatString = "<SERIES_LABEL>" + Environment.NewLine + "<ITEM_LABEL>: <DATA_VALUE:#.##>";
        }
    }
}